import { ref, reactive } from "vue";
import { styleIf } from "../../../types/style";
// 外层元素点击拖拽
const itemDrag = (
  ev: any,
  emit: Function,
  props: any,
  style: any,
  moveing: any
): void => {
  let press_x = ev.clientX;
  let press_y = ev.clientY;
  let target: any = ev.target || ev.srcElement;
  ev.stopPropagation();
  ev.preventDefault();

  emit("downHandler", {
    // 点击元素事件回调
    el: target,
    e: ev,
  });
  if (!props.isDraggable) return;
  //鼠标按下并移动的事件
  document.onmousemove = (e: any) => {
    if (e.movementX || e.movementY) {
      moveing.value = true;

      let offset_left = press_x - e.clientX;
      let offset_top = press_y - e.clientY;
      press_x = e.clientX;
      press_y = e.clientY;

      //绑定元素位置到positionX和positionY上面

      //移动当前元素
      style.top -= offset_top;
      style.left -= offset_left;
      emit("moveHandler", {
        // 移动事件回调
        el: target,
        e,
        top: style.top,
        left: style.left,
      });
    }
  };
  document.onmouseup = (e: any) => {
    moveing.value = false;
    if (style.left == style.back_left && style.top == style.back_top) {
      style.left = style.back_left;
      style.top = style.back_top;
    } else {
      emit("moveEndHandler", {
        // 抬起事件回调
        el: target,
        e,
        top: style.top,
        left: style.left,
      });
    }

    document.onmousemove = null;
    document.onmouseup = null;
  };
};
export default itemDrag;
